<html>
<head>
<title>OGRE: Ogre::AnimableObject Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1AnimableObject.html">AnimableObject</a></div>
<h1>Ogre::AnimableObject Class Reference</h1><!-- doxytag: class="Ogre::AnimableObject" -->Defines an interface to classes which have one or more <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, ie may be keyframed.">AnimableValue</a> instances to expose.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::AnimableObject:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1AnimableObject-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#cc4f830de60e226fbed772610eea93a4">AnimableObject</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#c61ca9c912e6b00bbe4fdd9ee0e56079">~AnimableObject</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#4239d192b2b08c4970dfaa22ce5a0cd0">getAnimableValueNames</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a list of animable value names for this object.  <a href="#4239d192b2b08c4970dfaa22ce5a0cd0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#b2cfac9af1b0d71c780ec969166b3585">createAnimableValue</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;valueName)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a reference-counted AnimableValuePtr for the named value.  <a href="#b2cfac9af1b0d71c780ec969166b3585"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>,<br>
 <a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#6855b757e0df1aae6d6b014466d4d25b">AnimableDictionaryMap</a></td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#7748b5ea03ba5eb10fdd79e455f96443">getAnimableDictionaryName</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the name of the animable dictionary for this class.  <a href="#7748b5ea03ba5eb10fdd79e455f96443"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#83629c5c4708cebd10c358a4be0722f5">createAnimableDictionary</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for creating a dictionary of animable value names for the class, if it does not already exist.  <a href="#83629c5c4708cebd10c358a4be0722f5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#20139173e816c296ab46d0548d1d4902">_getAnimableValueNames</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get an updateable reference to animable value list.  <a href="#20139173e816c296ab46d0548d1d4902"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#80abf1736a4241c432b30d2073c7a263">initialiseAnimableDictionary</a> (<a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> &amp;) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.  <a href="#80abf1736a4241c432b30d2073c7a263"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1AnimableObject.html#6855b757e0df1aae6d6b014466d4d25b">AnimableDictionaryMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html#1e2b199b8a10c3753ebeecc8fa773620">msAnimableDictionary</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Static map of class name to list of animable value names.  <a href="#1e2b199b8a10c3753ebeecc8fa773620"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Defines an interface to classes which have one or more <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, ie may be keyframed.">AnimableValue</a> instances to expose. 
<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00203">203</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="6855b757e0df1aae6d6b014466d4d25b"></a><!-- doxytag: member="Ogre::AnimableObject::AnimableDictionaryMap" ref="6855b757e0df1aae6d6b014466d4d25b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>&gt; <a class="el" href="classOgre_1_1AnimableObject.html#6855b757e0df1aae6d6b014466d4d25b">Ogre::AnimableObject::AnimableDictionaryMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00206">206</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="cc4f830de60e226fbed772610eea93a4"></a><!-- doxytag: member="Ogre::AnimableObject::AnimableObject" ref="cc4f830de60e226fbed772610eea93a4" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::AnimableObject::AnimableObject           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00256">256</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c61ca9c912e6b00bbe4fdd9ee0e56079"></a><!-- doxytag: member="Ogre::AnimableObject::~AnimableObject" ref="c61ca9c912e6b00bbe4fdd9ee0e56079" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::AnimableObject::~AnimableObject           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00257">257</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="7748b5ea03ba5eb10fdd79e455f96443"></a><!-- doxytag: member="Ogre::AnimableObject::getAnimableDictionaryName" ref="7748b5ea03ba5eb10fdd79e455f96443" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::AnimableObject::getAnimableDictionaryName           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the name of the animable dictionary for this class. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Subclasses must override this if they want to support animation of their values. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1Light.html#8b67ad3f3fe29c986f2298f9e462fae3">Ogre::Light</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00214">214</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

<p>References <a class="el" href="OgreString_8h-source.html#l00151">Ogre::StringUtil::BLANK</a>.</p>

</div>
</div><p>
<a class="anchor" name="83629c5c4708cebd10c358a4be0722f5"></a><!-- doxytag: member="Ogre::AnimableObject::createAnimableDictionary" ref="83629c5c4708cebd10c358a4be0722f5" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::AnimableObject::createAnimableDictionary           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for creating a dictionary of animable value names for the class, if it does not already exist. 
<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00219">219</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="20139173e816c296ab46d0548d1d4902"></a><!-- doxytag: member="Ogre::AnimableObject::_getAnimableValueNames" ref="20139173e816c296ab46d0548d1d4902" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>&amp; Ogre::AnimableObject::_getAnimableValueNames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get an updateable reference to animable value list. 
<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00232">232</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

<p>References <a class="el" href="OgreException_8h-source.html#l00108">Ogre::Exception::ERR_ITEM_NOT_FOUND</a>, and <a class="el" href="OgreException_8h-source.html#l00336">OGRE_EXCEPT</a>.</p>

</div>
</div><p>
<a class="anchor" name="80abf1736a4241c432b30d2073c7a263"></a><!-- doxytag: member="Ogre::AnimableObject::initialiseAnimableDictionary" ref="80abf1736a4241c432b30d2073c7a263" args="(StringVector &amp;) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimableObject::initialiseAnimableDictionary           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> &amp;&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1Light.html#3d2f217e88c62e3b2c2123085e71bc63">Ogre::Light</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00252">252</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4239d192b2b08c4970dfaa22ce5a0cd0"></a><!-- doxytag: member="Ogre::AnimableObject::getAnimableValueNames" ref="4239d192b2b08c4970dfaa22ce5a0cd0" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>&amp; Ogre::AnimableObject::getAnimableValueNames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a list of animable value names for this object. 
<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00260">260</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

<p>References <a class="el" href="OgreException_8h-source.html#l00108">Ogre::Exception::ERR_ITEM_NOT_FOUND</a>, and <a class="el" href="OgreException_8h-source.html#l00336">OGRE_EXCEPT</a>.</p>

</div>
</div><p>
<a class="anchor" name="b2cfac9af1b0d71c780ec969166b3585"></a><!-- doxytag: member="Ogre::AnimableObject::createAnimableValue" ref="b2cfac9af1b0d71c780ec969166b3585" args="(const String &amp;valueName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> Ogre::AnimableObject::createAnimableValue           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>valueName</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a reference-counted AnimableValuePtr for the named value. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can use the returned object to animate a value on this object, using <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, ie a sequence of keyframes which affect...">AnimationTrack</a>. Subclasses must override this if they wish to support animation of their values. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1Light.html#6e0be3df5d41752c0bedfcf9c89e492b">Ogre::Light</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00285">285</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

<p>References <a class="el" href="OgreException_8h-source.html#l00108">Ogre::Exception::ERR_ITEM_NOT_FOUND</a>, and <a class="el" href="OgreException_8h-source.html#l00336">OGRE_EXCEPT</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="1e2b199b8a10c3753ebeecc8fa773620"></a><!-- doxytag: member="Ogre::AnimableObject::msAnimableDictionary" ref="1e2b199b8a10c3753ebeecc8fa773620" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimableObject.html#6855b757e0df1aae6d6b014466d4d25b">AnimableDictionaryMap</a> <a class="el" href="classOgre_1_1AnimableObject.html#1e2b199b8a10c3753ebeecc8fa773620">Ogre::AnimableObject::msAnimableDictionary</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Static map of class name to list of animable value names. 
<p>

<p>Definition at line <a class="el" href="OgreAnimable_8h-source.html#l00208">208</a> of file <a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAnimable_8h-source.html">OgreAnimable.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:06 2008
</p>
</body>
</html>
